/**
 * This class with handle all the http request start with 'searchflight'
 */
package vt.CS5934.SwitchRoom.controllers;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import vt.CS5934.SwitchRoom.models.ResponseModel;
import vt.CS5934.SwitchRoom.models.SerachFlightModel;


@CrossOrigin
@RestController
@RequestMapping("searchflight")
public class SearchFlightController {

    private final Logger logger = LoggerFactory.getLogger(SearchFlightController.class);

//    @Autowired
//    OfferPageService offerPageService;

    @PostMapping("/newFlight")
    public ResponseModel createNewSearchFlight(@RequestBody SerachFlightModel newFlight){
        ResponseModel responseModel = new ResponseModel();
        try{
            responseModel.setMessage("Success");
            responseModel.setStatus(HttpStatus.OK);
            responseModel.setData(newFlight);
            return responseModel;
        }catch (Exception e){
            logger.error("Error in createSearchFlight: "+e);
            responseModel.setMessage("Failed, Reason: " + e);
            responseModel.setStatus(HttpStatus.NOT_FOUND);
            responseModel.setData(null);
            return responseModel;
        }
//        System.out.println(newFlight.getDestination());
//        return newFlight.getDestination();
    }


}
